//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ARCBigBenda[] cacheARCBigBenda = null;
        private ARCDonchain[] cacheARCDonchain = null;
        private ARCEmafan[] cacheARCEmafan = null;
        private ARCMacDiv[] cacheARCMacDiv = null;
        private ARCNR10[] cacheARCNR10 = null;
        private ARCPinBar[] cacheARCPinBar = null;
        private ARCRetracer[] cacheARCRetracer = null;
        private ARCSQ1001[] cacheARCSQ1001 = null;
        private ARCTimeOfDay[] cacheARCTimeOfDay = null;

        private static ARCBigBenda checkARCBigBenda = new ARCBigBenda();
        private static ARCDonchain checkARCDonchain = new ARCDonchain();
        private static ARCEmafan checkARCEmafan = new ARCEmafan();
        private static ARCMacDiv checkARCMacDiv = new ARCMacDiv();
        private static ARCNR10 checkARCNR10 = new ARCNR10();
        private static ARCPinBar checkARCPinBar = new ARCPinBar();
        private static ARCRetracer checkARCRetracer = new ARCRetracer();
        private static ARCSQ1001 checkARCSQ1001 = new ARCSQ1001();
        private static ARCTimeOfDay checkARCTimeOfDay = new ARCTimeOfDay();

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public ARCBigBenda ARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return ARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public ARCBigBenda ARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            if (cacheARCBigBenda != null)
                for (int idx = 0; idx < cacheARCBigBenda.Length; idx++)
                    if (cacheARCBigBenda[idx].Countback == countback && Math.Abs(cacheARCBigBenda[idx].Countbackoffset - countbackoffset) <= double.Epsilon && cacheARCBigBenda[idx].Divergenceon == divergenceon && cacheARCBigBenda[idx].FTPeriod == fTPeriod && cacheARCBigBenda[idx].Seperation == seperation && cacheARCBigBenda[idx].Textbb == textbb && cacheARCBigBenda[idx].Texton == texton && cacheARCBigBenda[idx].Thistimeperiodon == thistimeperiodon && cacheARCBigBenda[idx].TimeFrame == timeFrame && Math.Abs(cacheARCBigBenda[idx].Zerooffset - zerooffset) <= double.Epsilon && cacheARCBigBenda[idx].Zzstrategyuse == zzstrategyuse && cacheARCBigBenda[idx].EqualsInput(input))
                        return cacheARCBigBenda[idx];

            lock (checkARCBigBenda)
            {
                checkARCBigBenda.Countback = countback;
                countback = checkARCBigBenda.Countback;
                checkARCBigBenda.Countbackoffset = countbackoffset;
                countbackoffset = checkARCBigBenda.Countbackoffset;
                checkARCBigBenda.Divergenceon = divergenceon;
                divergenceon = checkARCBigBenda.Divergenceon;
                checkARCBigBenda.FTPeriod = fTPeriod;
                fTPeriod = checkARCBigBenda.FTPeriod;
                checkARCBigBenda.Seperation = seperation;
                seperation = checkARCBigBenda.Seperation;
                checkARCBigBenda.Textbb = textbb;
                textbb = checkARCBigBenda.Textbb;
                checkARCBigBenda.Texton = texton;
                texton = checkARCBigBenda.Texton;
                checkARCBigBenda.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkARCBigBenda.Thistimeperiodon;
                checkARCBigBenda.TimeFrame = timeFrame;
                timeFrame = checkARCBigBenda.TimeFrame;
                checkARCBigBenda.Zerooffset = zerooffset;
                zerooffset = checkARCBigBenda.Zerooffset;
                checkARCBigBenda.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkARCBigBenda.Zzstrategyuse;

                if (cacheARCBigBenda != null)
                    for (int idx = 0; idx < cacheARCBigBenda.Length; idx++)
                        if (cacheARCBigBenda[idx].Countback == countback && Math.Abs(cacheARCBigBenda[idx].Countbackoffset - countbackoffset) <= double.Epsilon && cacheARCBigBenda[idx].Divergenceon == divergenceon && cacheARCBigBenda[idx].FTPeriod == fTPeriod && cacheARCBigBenda[idx].Seperation == seperation && cacheARCBigBenda[idx].Textbb == textbb && cacheARCBigBenda[idx].Texton == texton && cacheARCBigBenda[idx].Thistimeperiodon == thistimeperiodon && cacheARCBigBenda[idx].TimeFrame == timeFrame && Math.Abs(cacheARCBigBenda[idx].Zerooffset - zerooffset) <= double.Epsilon && cacheARCBigBenda[idx].Zzstrategyuse == zzstrategyuse && cacheARCBigBenda[idx].EqualsInput(input))
                            return cacheARCBigBenda[idx];

                ARCBigBenda indicator = new ARCBigBenda();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Countback = countback;
                indicator.Countbackoffset = countbackoffset;
                indicator.Divergenceon = divergenceon;
                indicator.FTPeriod = fTPeriod;
                indicator.Seperation = seperation;
                indicator.Textbb = textbb;
                indicator.Texton = texton;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeFrame = timeFrame;
                indicator.Zerooffset = zerooffset;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCBigBenda[] tmp = new ARCBigBenda[cacheARCBigBenda == null ? 1 : cacheARCBigBenda.Length + 1];
                if (cacheARCBigBenda != null)
                    cacheARCBigBenda.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCBigBenda = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public ARCDonchain ARCDonchain(int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return ARCDonchain(Input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public ARCDonchain ARCDonchain(Data.IDataSeries input, int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            if (cacheARCDonchain != null)
                for (int idx = 0; idx < cacheARCDonchain.Length; idx++)
                    if (cacheARCDonchain[idx].PeriodA == periodA && cacheARCDonchain[idx].PeriodB == periodB && cacheARCDonchain[idx].PeriodC == periodC && cacheARCDonchain[idx].PeriodD == periodD && cacheARCDonchain[idx].PeriodE == periodE && cacheARCDonchain[idx].EqualsInput(input))
                        return cacheARCDonchain[idx];

            lock (checkARCDonchain)
            {
                checkARCDonchain.PeriodA = periodA;
                periodA = checkARCDonchain.PeriodA;
                checkARCDonchain.PeriodB = periodB;
                periodB = checkARCDonchain.PeriodB;
                checkARCDonchain.PeriodC = periodC;
                periodC = checkARCDonchain.PeriodC;
                checkARCDonchain.PeriodD = periodD;
                periodD = checkARCDonchain.PeriodD;
                checkARCDonchain.PeriodE = periodE;
                periodE = checkARCDonchain.PeriodE;

                if (cacheARCDonchain != null)
                    for (int idx = 0; idx < cacheARCDonchain.Length; idx++)
                        if (cacheARCDonchain[idx].PeriodA == periodA && cacheARCDonchain[idx].PeriodB == periodB && cacheARCDonchain[idx].PeriodC == periodC && cacheARCDonchain[idx].PeriodD == periodD && cacheARCDonchain[idx].PeriodE == periodE && cacheARCDonchain[idx].EqualsInput(input))
                            return cacheARCDonchain[idx];

                ARCDonchain indicator = new ARCDonchain();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.PeriodA = periodA;
                indicator.PeriodB = periodB;
                indicator.PeriodC = periodC;
                indicator.PeriodD = periodD;
                indicator.PeriodE = periodE;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCDonchain[] tmp = new ARCDonchain[cacheARCDonchain == null ? 1 : cacheARCDonchain.Length + 1];
                if (cacheARCDonchain != null)
                    cacheARCDonchain.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCDonchain = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public ARCEmafan ARCEmafan(int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return ARCEmafan(Input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public ARCEmafan ARCEmafan(Data.IDataSeries input, int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            if (cacheARCEmafan != null)
                for (int idx = 0; idx < cacheARCEmafan.Length; idx++)
                    if (cacheARCEmafan[idx].Fema1 == fema1 && cacheARCEmafan[idx].Fema2 == fema2 && cacheARCEmafan[idx].Fema3 == fema3 && cacheARCEmafan[idx].Fema4 == fema4 && cacheARCEmafan[idx].Fema5 == fema5 && cacheARCEmafan[idx].Fema6 == fema6 && cacheARCEmafan[idx].Fema7 == fema7 && cacheARCEmafan[idx].Risingon == risingon && cacheARCEmafan[idx].Zzstrategyuse == zzstrategyuse && cacheARCEmafan[idx].EqualsInput(input))
                        return cacheARCEmafan[idx];

            lock (checkARCEmafan)
            {
                checkARCEmafan.Fema1 = fema1;
                fema1 = checkARCEmafan.Fema1;
                checkARCEmafan.Fema2 = fema2;
                fema2 = checkARCEmafan.Fema2;
                checkARCEmafan.Fema3 = fema3;
                fema3 = checkARCEmafan.Fema3;
                checkARCEmafan.Fema4 = fema4;
                fema4 = checkARCEmafan.Fema4;
                checkARCEmafan.Fema5 = fema5;
                fema5 = checkARCEmafan.Fema5;
                checkARCEmafan.Fema6 = fema6;
                fema6 = checkARCEmafan.Fema6;
                checkARCEmafan.Fema7 = fema7;
                fema7 = checkARCEmafan.Fema7;
                checkARCEmafan.Risingon = risingon;
                risingon = checkARCEmafan.Risingon;
                checkARCEmafan.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkARCEmafan.Zzstrategyuse;

                if (cacheARCEmafan != null)
                    for (int idx = 0; idx < cacheARCEmafan.Length; idx++)
                        if (cacheARCEmafan[idx].Fema1 == fema1 && cacheARCEmafan[idx].Fema2 == fema2 && cacheARCEmafan[idx].Fema3 == fema3 && cacheARCEmafan[idx].Fema4 == fema4 && cacheARCEmafan[idx].Fema5 == fema5 && cacheARCEmafan[idx].Fema6 == fema6 && cacheARCEmafan[idx].Fema7 == fema7 && cacheARCEmafan[idx].Risingon == risingon && cacheARCEmafan[idx].Zzstrategyuse == zzstrategyuse && cacheARCEmafan[idx].EqualsInput(input))
                            return cacheARCEmafan[idx];

                ARCEmafan indicator = new ARCEmafan();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Fema1 = fema1;
                indicator.Fema2 = fema2;
                indicator.Fema3 = fema3;
                indicator.Fema4 = fema4;
                indicator.Fema5 = fema5;
                indicator.Fema6 = fema6;
                indicator.Fema7 = fema7;
                indicator.Risingon = risingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCEmafan[] tmp = new ARCEmafan[cacheARCEmafan == null ? 1 : cacheARCEmafan.Length + 1];
                if (cacheARCEmafan != null)
                    cacheARCEmafan.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCEmafan = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ARCMacDiv ARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return ARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ARCMacDiv ARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            if (cacheARCMacDiv != null)
                for (int idx = 0; idx < cacheARCMacDiv.Length; idx++)
                    if (cacheARCMacDiv[idx].Afast == afast && cacheARCMacDiv[idx].Aslow == aslow && cacheARCMacDiv[idx].Asmooth == asmooth && cacheARCMacDiv[idx].MacdCountback == macdCountback && cacheARCMacDiv[idx].Macdtrigtext == macdtrigtext && cacheARCMacDiv[idx].Seperation == seperation && cacheARCMacDiv[idx].Thistimeperiodon == thistimeperiodon && cacheARCMacDiv[idx].TimeFrame == timeFrame && cacheARCMacDiv[idx].Timmingzone == timmingzone && cacheARCMacDiv[idx].Wordingon == wordingon && cacheARCMacDiv[idx].Zzstrategyuse == zzstrategyuse && cacheARCMacDiv[idx].EqualsInput(input))
                        return cacheARCMacDiv[idx];

            lock (checkARCMacDiv)
            {
                checkARCMacDiv.Afast = afast;
                afast = checkARCMacDiv.Afast;
                checkARCMacDiv.Aslow = aslow;
                aslow = checkARCMacDiv.Aslow;
                checkARCMacDiv.Asmooth = asmooth;
                asmooth = checkARCMacDiv.Asmooth;
                checkARCMacDiv.MacdCountback = macdCountback;
                macdCountback = checkARCMacDiv.MacdCountback;
                checkARCMacDiv.Macdtrigtext = macdtrigtext;
                macdtrigtext = checkARCMacDiv.Macdtrigtext;
                checkARCMacDiv.Seperation = seperation;
                seperation = checkARCMacDiv.Seperation;
                checkARCMacDiv.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkARCMacDiv.Thistimeperiodon;
                checkARCMacDiv.TimeFrame = timeFrame;
                timeFrame = checkARCMacDiv.TimeFrame;
                checkARCMacDiv.Timmingzone = timmingzone;
                timmingzone = checkARCMacDiv.Timmingzone;
                checkARCMacDiv.Wordingon = wordingon;
                wordingon = checkARCMacDiv.Wordingon;
                checkARCMacDiv.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkARCMacDiv.Zzstrategyuse;

                if (cacheARCMacDiv != null)
                    for (int idx = 0; idx < cacheARCMacDiv.Length; idx++)
                        if (cacheARCMacDiv[idx].Afast == afast && cacheARCMacDiv[idx].Aslow == aslow && cacheARCMacDiv[idx].Asmooth == asmooth && cacheARCMacDiv[idx].MacdCountback == macdCountback && cacheARCMacDiv[idx].Macdtrigtext == macdtrigtext && cacheARCMacDiv[idx].Seperation == seperation && cacheARCMacDiv[idx].Thistimeperiodon == thistimeperiodon && cacheARCMacDiv[idx].TimeFrame == timeFrame && cacheARCMacDiv[idx].Timmingzone == timmingzone && cacheARCMacDiv[idx].Wordingon == wordingon && cacheARCMacDiv[idx].Zzstrategyuse == zzstrategyuse && cacheARCMacDiv[idx].EqualsInput(input))
                            return cacheARCMacDiv[idx];

                ARCMacDiv indicator = new ARCMacDiv();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Afast = afast;
                indicator.Aslow = aslow;
                indicator.Asmooth = asmooth;
                indicator.MacdCountback = macdCountback;
                indicator.Macdtrigtext = macdtrigtext;
                indicator.Seperation = seperation;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeFrame = timeFrame;
                indicator.Timmingzone = timmingzone;
                indicator.Wordingon = wordingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCMacDiv[] tmp = new ARCMacDiv[cacheARCMacDiv == null ? 1 : cacheARCMacDiv.Length + 1];
                if (cacheARCMacDiv != null)
                    cacheARCMacDiv.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCMacDiv = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public ARCNR10 ARCNR10(string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return ARCNR10(Input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public ARCNR10 ARCNR10(Data.IDataSeries input, string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            if (cacheARCNR10 != null)
                for (int idx = 0; idx < cacheARCNR10.Length; idx++)
                    if (cacheARCNR10[idx].Nr10text == nr10text && cacheARCNR10[idx].Period == period && cacheARCNR10[idx].Seperation == seperation && cacheARCNR10[idx].Wordingon == wordingon && cacheARCNR10[idx].Zstrategyuse == zstrategyuse && cacheARCNR10[idx].EqualsInput(input))
                        return cacheARCNR10[idx];

            lock (checkARCNR10)
            {
                checkARCNR10.Nr10text = nr10text;
                nr10text = checkARCNR10.Nr10text;
                checkARCNR10.Period = period;
                period = checkARCNR10.Period;
                checkARCNR10.Seperation = seperation;
                seperation = checkARCNR10.Seperation;
                checkARCNR10.Wordingon = wordingon;
                wordingon = checkARCNR10.Wordingon;
                checkARCNR10.Zstrategyuse = zstrategyuse;
                zstrategyuse = checkARCNR10.Zstrategyuse;

                if (cacheARCNR10 != null)
                    for (int idx = 0; idx < cacheARCNR10.Length; idx++)
                        if (cacheARCNR10[idx].Nr10text == nr10text && cacheARCNR10[idx].Period == period && cacheARCNR10[idx].Seperation == seperation && cacheARCNR10[idx].Wordingon == wordingon && cacheARCNR10[idx].Zstrategyuse == zstrategyuse && cacheARCNR10[idx].EqualsInput(input))
                            return cacheARCNR10[idx];

                ARCNR10 indicator = new ARCNR10();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Nr10text = nr10text;
                indicator.Period = period;
                indicator.Seperation = seperation;
                indicator.Wordingon = wordingon;
                indicator.Zstrategyuse = zstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCNR10[] tmp = new ARCNR10[cacheARCNR10 == null ? 1 : cacheARCNR10.Length + 1];
                if (cacheARCNR10 != null)
                    cacheARCNR10.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCNR10 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public ARCPinBar ARCPinBar(int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return ARCPinBar(Input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public ARCPinBar ARCPinBar(Data.IDataSeries input, int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            if (cacheARCPinBar != null)
                for (int idx = 0; idx < cacheARCPinBar.Length; idx++)
                    if (cacheARCPinBar[idx].Barcount == barcount && cacheARCPinBar[idx].Bearpintext == bearpintext && Math.Abs(cacheARCPinBar[idx].Bodysize - bodysize) <= double.Epsilon && cacheARCPinBar[idx].Bullpintext == bullpintext && cacheARCPinBar[idx].Seperation == seperation && cacheARCPinBar[idx].Thistimeperiodon == thistimeperiodon && cacheARCPinBar[idx].TimeperiodA == timeperiodA && cacheARCPinBar[idx].TimeperiodB == timeperiodB && cacheARCPinBar[idx].Timeperiodon == timeperiodon && cacheARCPinBar[idx].Wordingon == wordingon && cacheARCPinBar[idx].Zzstrategyuse == zzstrategyuse && cacheARCPinBar[idx].EqualsInput(input))
                        return cacheARCPinBar[idx];

            lock (checkARCPinBar)
            {
                checkARCPinBar.Barcount = barcount;
                barcount = checkARCPinBar.Barcount;
                checkARCPinBar.Bearpintext = bearpintext;
                bearpintext = checkARCPinBar.Bearpintext;
                checkARCPinBar.Bodysize = bodysize;
                bodysize = checkARCPinBar.Bodysize;
                checkARCPinBar.Bullpintext = bullpintext;
                bullpintext = checkARCPinBar.Bullpintext;
                checkARCPinBar.Seperation = seperation;
                seperation = checkARCPinBar.Seperation;
                checkARCPinBar.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkARCPinBar.Thistimeperiodon;
                checkARCPinBar.TimeperiodA = timeperiodA;
                timeperiodA = checkARCPinBar.TimeperiodA;
                checkARCPinBar.TimeperiodB = timeperiodB;
                timeperiodB = checkARCPinBar.TimeperiodB;
                checkARCPinBar.Timeperiodon = timeperiodon;
                timeperiodon = checkARCPinBar.Timeperiodon;
                checkARCPinBar.Wordingon = wordingon;
                wordingon = checkARCPinBar.Wordingon;
                checkARCPinBar.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkARCPinBar.Zzstrategyuse;

                if (cacheARCPinBar != null)
                    for (int idx = 0; idx < cacheARCPinBar.Length; idx++)
                        if (cacheARCPinBar[idx].Barcount == barcount && cacheARCPinBar[idx].Bearpintext == bearpintext && Math.Abs(cacheARCPinBar[idx].Bodysize - bodysize) <= double.Epsilon && cacheARCPinBar[idx].Bullpintext == bullpintext && cacheARCPinBar[idx].Seperation == seperation && cacheARCPinBar[idx].Thistimeperiodon == thistimeperiodon && cacheARCPinBar[idx].TimeperiodA == timeperiodA && cacheARCPinBar[idx].TimeperiodB == timeperiodB && cacheARCPinBar[idx].Timeperiodon == timeperiodon && cacheARCPinBar[idx].Wordingon == wordingon && cacheARCPinBar[idx].Zzstrategyuse == zzstrategyuse && cacheARCPinBar[idx].EqualsInput(input))
                            return cacheARCPinBar[idx];

                ARCPinBar indicator = new ARCPinBar();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Barcount = barcount;
                indicator.Bearpintext = bearpintext;
                indicator.Bodysize = bodysize;
                indicator.Bullpintext = bullpintext;
                indicator.Seperation = seperation;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeperiodA = timeperiodA;
                indicator.TimeperiodB = timeperiodB;
                indicator.Timeperiodon = timeperiodon;
                indicator.Wordingon = wordingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCPinBar[] tmp = new ARCPinBar[cacheARCPinBar == null ? 1 : cacheARCPinBar.Length + 1];
                if (cacheARCPinBar != null)
                    cacheARCPinBar.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCPinBar = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public ARCRetracer ARCRetracer(int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return ARCRetracer(Input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public ARCRetracer ARCRetracer(Data.IDataSeries input, int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            if (cacheARCRetracer != null)
                for (int idx = 0; idx < cacheARCRetracer.Length; idx++)
                    if (cacheARCRetracer[idx].Counter == counter && cacheARCRetracer[idx].ReTracetext == reTracetext && cacheARCRetracer[idx].Seperation == seperation && cacheARCRetracer[idx].Trend == trend && cacheARCRetracer[idx].Wordingon == wordingon && cacheARCRetracer[idx].Zzstrategyuse == zzstrategyuse && cacheARCRetracer[idx].EqualsInput(input))
                        return cacheARCRetracer[idx];

            lock (checkARCRetracer)
            {
                checkARCRetracer.Counter = counter;
                counter = checkARCRetracer.Counter;
                checkARCRetracer.ReTracetext = reTracetext;
                reTracetext = checkARCRetracer.ReTracetext;
                checkARCRetracer.Seperation = seperation;
                seperation = checkARCRetracer.Seperation;
                checkARCRetracer.Trend = trend;
                trend = checkARCRetracer.Trend;
                checkARCRetracer.Wordingon = wordingon;
                wordingon = checkARCRetracer.Wordingon;
                checkARCRetracer.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkARCRetracer.Zzstrategyuse;

                if (cacheARCRetracer != null)
                    for (int idx = 0; idx < cacheARCRetracer.Length; idx++)
                        if (cacheARCRetracer[idx].Counter == counter && cacheARCRetracer[idx].ReTracetext == reTracetext && cacheARCRetracer[idx].Seperation == seperation && cacheARCRetracer[idx].Trend == trend && cacheARCRetracer[idx].Wordingon == wordingon && cacheARCRetracer[idx].Zzstrategyuse == zzstrategyuse && cacheARCRetracer[idx].EqualsInput(input))
                            return cacheARCRetracer[idx];

                ARCRetracer indicator = new ARCRetracer();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Counter = counter;
                indicator.ReTracetext = reTracetext;
                indicator.Seperation = seperation;
                indicator.Trend = trend;
                indicator.Wordingon = wordingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCRetracer[] tmp = new ARCRetracer[cacheARCRetracer == null ? 1 : cacheARCRetracer.Length + 1];
                if (cacheARCRetracer != null)
                    cacheARCRetracer.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCRetracer = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ARCSQ1001 ARCSQ1001(int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return ARCSQ1001(Input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ARCSQ1001 ARCSQ1001(Data.IDataSeries input, int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            if (cacheARCSQ1001 != null)
                for (int idx = 0; idx < cacheARCSQ1001.Length; idx++)
                    if (cacheARCSQ1001[idx].Ema1 == ema1 && cacheARCSQ1001[idx].Entry == entry && cacheARCSQ1001[idx].Exit == exit && cacheARCSQ1001[idx].Seperation == seperation && cacheARCSQ1001[idx].Trend == trend && Math.Abs(cacheARCSQ1001[idx].Zone - zone) <= double.Epsilon && cacheARCSQ1001[idx].Zstrategyuse == zstrategyuse && cacheARCSQ1001[idx].EqualsInput(input))
                        return cacheARCSQ1001[idx];

            lock (checkARCSQ1001)
            {
                checkARCSQ1001.Ema1 = ema1;
                ema1 = checkARCSQ1001.Ema1;
                checkARCSQ1001.Entry = entry;
                entry = checkARCSQ1001.Entry;
                checkARCSQ1001.Exit = exit;
                exit = checkARCSQ1001.Exit;
                checkARCSQ1001.Seperation = seperation;
                seperation = checkARCSQ1001.Seperation;
                checkARCSQ1001.Trend = trend;
                trend = checkARCSQ1001.Trend;
                checkARCSQ1001.Zone = zone;
                zone = checkARCSQ1001.Zone;
                checkARCSQ1001.Zstrategyuse = zstrategyuse;
                zstrategyuse = checkARCSQ1001.Zstrategyuse;

                if (cacheARCSQ1001 != null)
                    for (int idx = 0; idx < cacheARCSQ1001.Length; idx++)
                        if (cacheARCSQ1001[idx].Ema1 == ema1 && cacheARCSQ1001[idx].Entry == entry && cacheARCSQ1001[idx].Exit == exit && cacheARCSQ1001[idx].Seperation == seperation && cacheARCSQ1001[idx].Trend == trend && Math.Abs(cacheARCSQ1001[idx].Zone - zone) <= double.Epsilon && cacheARCSQ1001[idx].Zstrategyuse == zstrategyuse && cacheARCSQ1001[idx].EqualsInput(input))
                            return cacheARCSQ1001[idx];

                ARCSQ1001 indicator = new ARCSQ1001();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Ema1 = ema1;
                indicator.Entry = entry;
                indicator.Exit = exit;
                indicator.Seperation = seperation;
                indicator.Trend = trend;
                indicator.Zone = zone;
                indicator.Zstrategyuse = zstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCSQ1001[] tmp = new ARCSQ1001[cacheARCSQ1001 == null ? 1 : cacheARCSQ1001.Length + 1];
                if (cacheARCSQ1001 != null)
                    cacheARCSQ1001.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCSQ1001 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public ARCTimeOfDay ARCTimeOfDay(int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return ARCTimeOfDay(Input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public ARCTimeOfDay ARCTimeOfDay(Data.IDataSeries input, int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            if (cacheARCTimeOfDay != null)
                for (int idx = 0; idx < cacheARCTimeOfDay.Length; idx++)
                    if (cacheARCTimeOfDay[idx].Apenw == apenw && cacheARCTimeOfDay[idx].Bz1 == bz1 && cacheARCTimeOfDay[idx].Bz2 == bz2 && cacheARCTimeOfDay[idx].D1Buy1 == d1Buy1 && cacheARCTimeOfDay[idx].D1Buy2 == d1Buy2 && cacheARCTimeOfDay[idx].D1Sell1 == d1Sell1 && cacheARCTimeOfDay[idx].D1Sell2 == d1Sell2 && cacheARCTimeOfDay[idx].D2Buy1 == d2Buy1 && cacheARCTimeOfDay[idx].D2Buy2 == d2Buy2 && cacheARCTimeOfDay[idx].D2Sell1 == d2Sell1 && cacheARCTimeOfDay[idx].D2Sell2 == d2Sell2 && cacheARCTimeOfDay[idx].D3Buy1 == d3Buy1 && cacheARCTimeOfDay[idx].D3Buy2 == d3Buy2 && cacheARCTimeOfDay[idx].D3Sell1 == d3Sell1 && cacheARCTimeOfDay[idx].D3Sell2 == d3Sell2 && cacheARCTimeOfDay[idx].D4Buy1 == d4Buy1 && cacheARCTimeOfDay[idx].D4Buy2 == d4Buy2 && cacheARCTimeOfDay[idx].D4Sell1 == d4Sell1 && cacheARCTimeOfDay[idx].D4Sell2 == d4Sell2 && cacheARCTimeOfDay[idx].D5Buy1 == d5Buy1 && cacheARCTimeOfDay[idx].D5Buy2 == d5Buy2 && cacheARCTimeOfDay[idx].D5Sell1 == d5Sell1 && cacheARCTimeOfDay[idx].D5Sell2 == d5Sell2 && cacheARCTimeOfDay[idx].D6Buy1 == d6Buy1 && cacheARCTimeOfDay[idx].D6Buy2 == d6Buy2 && cacheARCTimeOfDay[idx].D6Sell1 == d6Sell1 && cacheARCTimeOfDay[idx].D6Sell2 == d6Sell2 && cacheARCTimeOfDay[idx].D7Buy1 == d7Buy1 && cacheARCTimeOfDay[idx].D7Buy2 == d7Buy2 && cacheARCTimeOfDay[idx].D7Sell1 == d7Sell1 && cacheARCTimeOfDay[idx].D7Sell2 == d7Sell2 && cacheARCTimeOfDay[idx].Sz1 == sz1 && cacheARCTimeOfDay[idx].Sz2 == sz2 && cacheARCTimeOfDay[idx].Zone == zone && cacheARCTimeOfDay[idx].Zseperation == zseperation && cacheARCTimeOfDay[idx].Zzstrategyuse == zzstrategyuse && cacheARCTimeOfDay[idx].EqualsInput(input))
                        return cacheARCTimeOfDay[idx];

            lock (checkARCTimeOfDay)
            {
                checkARCTimeOfDay.Apenw = apenw;
                apenw = checkARCTimeOfDay.Apenw;
                checkARCTimeOfDay.Bz1 = bz1;
                bz1 = checkARCTimeOfDay.Bz1;
                checkARCTimeOfDay.Bz2 = bz2;
                bz2 = checkARCTimeOfDay.Bz2;
                checkARCTimeOfDay.D1Buy1 = d1Buy1;
                d1Buy1 = checkARCTimeOfDay.D1Buy1;
                checkARCTimeOfDay.D1Buy2 = d1Buy2;
                d1Buy2 = checkARCTimeOfDay.D1Buy2;
                checkARCTimeOfDay.D1Sell1 = d1Sell1;
                d1Sell1 = checkARCTimeOfDay.D1Sell1;
                checkARCTimeOfDay.D1Sell2 = d1Sell2;
                d1Sell2 = checkARCTimeOfDay.D1Sell2;
                checkARCTimeOfDay.D2Buy1 = d2Buy1;
                d2Buy1 = checkARCTimeOfDay.D2Buy1;
                checkARCTimeOfDay.D2Buy2 = d2Buy2;
                d2Buy2 = checkARCTimeOfDay.D2Buy2;
                checkARCTimeOfDay.D2Sell1 = d2Sell1;
                d2Sell1 = checkARCTimeOfDay.D2Sell1;
                checkARCTimeOfDay.D2Sell2 = d2Sell2;
                d2Sell2 = checkARCTimeOfDay.D2Sell2;
                checkARCTimeOfDay.D3Buy1 = d3Buy1;
                d3Buy1 = checkARCTimeOfDay.D3Buy1;
                checkARCTimeOfDay.D3Buy2 = d3Buy2;
                d3Buy2 = checkARCTimeOfDay.D3Buy2;
                checkARCTimeOfDay.D3Sell1 = d3Sell1;
                d3Sell1 = checkARCTimeOfDay.D3Sell1;
                checkARCTimeOfDay.D3Sell2 = d3Sell2;
                d3Sell2 = checkARCTimeOfDay.D3Sell2;
                checkARCTimeOfDay.D4Buy1 = d4Buy1;
                d4Buy1 = checkARCTimeOfDay.D4Buy1;
                checkARCTimeOfDay.D4Buy2 = d4Buy2;
                d4Buy2 = checkARCTimeOfDay.D4Buy2;
                checkARCTimeOfDay.D4Sell1 = d4Sell1;
                d4Sell1 = checkARCTimeOfDay.D4Sell1;
                checkARCTimeOfDay.D4Sell2 = d4Sell2;
                d4Sell2 = checkARCTimeOfDay.D4Sell2;
                checkARCTimeOfDay.D5Buy1 = d5Buy1;
                d5Buy1 = checkARCTimeOfDay.D5Buy1;
                checkARCTimeOfDay.D5Buy2 = d5Buy2;
                d5Buy2 = checkARCTimeOfDay.D5Buy2;
                checkARCTimeOfDay.D5Sell1 = d5Sell1;
                d5Sell1 = checkARCTimeOfDay.D5Sell1;
                checkARCTimeOfDay.D5Sell2 = d5Sell2;
                d5Sell2 = checkARCTimeOfDay.D5Sell2;
                checkARCTimeOfDay.D6Buy1 = d6Buy1;
                d6Buy1 = checkARCTimeOfDay.D6Buy1;
                checkARCTimeOfDay.D6Buy2 = d6Buy2;
                d6Buy2 = checkARCTimeOfDay.D6Buy2;
                checkARCTimeOfDay.D6Sell1 = d6Sell1;
                d6Sell1 = checkARCTimeOfDay.D6Sell1;
                checkARCTimeOfDay.D6Sell2 = d6Sell2;
                d6Sell2 = checkARCTimeOfDay.D6Sell2;
                checkARCTimeOfDay.D7Buy1 = d7Buy1;
                d7Buy1 = checkARCTimeOfDay.D7Buy1;
                checkARCTimeOfDay.D7Buy2 = d7Buy2;
                d7Buy2 = checkARCTimeOfDay.D7Buy2;
                checkARCTimeOfDay.D7Sell1 = d7Sell1;
                d7Sell1 = checkARCTimeOfDay.D7Sell1;
                checkARCTimeOfDay.D7Sell2 = d7Sell2;
                d7Sell2 = checkARCTimeOfDay.D7Sell2;
                checkARCTimeOfDay.Sz1 = sz1;
                sz1 = checkARCTimeOfDay.Sz1;
                checkARCTimeOfDay.Sz2 = sz2;
                sz2 = checkARCTimeOfDay.Sz2;
                checkARCTimeOfDay.Zone = zone;
                zone = checkARCTimeOfDay.Zone;
                checkARCTimeOfDay.Zseperation = zseperation;
                zseperation = checkARCTimeOfDay.Zseperation;
                checkARCTimeOfDay.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkARCTimeOfDay.Zzstrategyuse;

                if (cacheARCTimeOfDay != null)
                    for (int idx = 0; idx < cacheARCTimeOfDay.Length; idx++)
                        if (cacheARCTimeOfDay[idx].Apenw == apenw && cacheARCTimeOfDay[idx].Bz1 == bz1 && cacheARCTimeOfDay[idx].Bz2 == bz2 && cacheARCTimeOfDay[idx].D1Buy1 == d1Buy1 && cacheARCTimeOfDay[idx].D1Buy2 == d1Buy2 && cacheARCTimeOfDay[idx].D1Sell1 == d1Sell1 && cacheARCTimeOfDay[idx].D1Sell2 == d1Sell2 && cacheARCTimeOfDay[idx].D2Buy1 == d2Buy1 && cacheARCTimeOfDay[idx].D2Buy2 == d2Buy2 && cacheARCTimeOfDay[idx].D2Sell1 == d2Sell1 && cacheARCTimeOfDay[idx].D2Sell2 == d2Sell2 && cacheARCTimeOfDay[idx].D3Buy1 == d3Buy1 && cacheARCTimeOfDay[idx].D3Buy2 == d3Buy2 && cacheARCTimeOfDay[idx].D3Sell1 == d3Sell1 && cacheARCTimeOfDay[idx].D3Sell2 == d3Sell2 && cacheARCTimeOfDay[idx].D4Buy1 == d4Buy1 && cacheARCTimeOfDay[idx].D4Buy2 == d4Buy2 && cacheARCTimeOfDay[idx].D4Sell1 == d4Sell1 && cacheARCTimeOfDay[idx].D4Sell2 == d4Sell2 && cacheARCTimeOfDay[idx].D5Buy1 == d5Buy1 && cacheARCTimeOfDay[idx].D5Buy2 == d5Buy2 && cacheARCTimeOfDay[idx].D5Sell1 == d5Sell1 && cacheARCTimeOfDay[idx].D5Sell2 == d5Sell2 && cacheARCTimeOfDay[idx].D6Buy1 == d6Buy1 && cacheARCTimeOfDay[idx].D6Buy2 == d6Buy2 && cacheARCTimeOfDay[idx].D6Sell1 == d6Sell1 && cacheARCTimeOfDay[idx].D6Sell2 == d6Sell2 && cacheARCTimeOfDay[idx].D7Buy1 == d7Buy1 && cacheARCTimeOfDay[idx].D7Buy2 == d7Buy2 && cacheARCTimeOfDay[idx].D7Sell1 == d7Sell1 && cacheARCTimeOfDay[idx].D7Sell2 == d7Sell2 && cacheARCTimeOfDay[idx].Sz1 == sz1 && cacheARCTimeOfDay[idx].Sz2 == sz2 && cacheARCTimeOfDay[idx].Zone == zone && cacheARCTimeOfDay[idx].Zseperation == zseperation && cacheARCTimeOfDay[idx].Zzstrategyuse == zzstrategyuse && cacheARCTimeOfDay[idx].EqualsInput(input))
                            return cacheARCTimeOfDay[idx];

                ARCTimeOfDay indicator = new ARCTimeOfDay();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Apenw = apenw;
                indicator.Bz1 = bz1;
                indicator.Bz2 = bz2;
                indicator.D1Buy1 = d1Buy1;
                indicator.D1Buy2 = d1Buy2;
                indicator.D1Sell1 = d1Sell1;
                indicator.D1Sell2 = d1Sell2;
                indicator.D2Buy1 = d2Buy1;
                indicator.D2Buy2 = d2Buy2;
                indicator.D2Sell1 = d2Sell1;
                indicator.D2Sell2 = d2Sell2;
                indicator.D3Buy1 = d3Buy1;
                indicator.D3Buy2 = d3Buy2;
                indicator.D3Sell1 = d3Sell1;
                indicator.D3Sell2 = d3Sell2;
                indicator.D4Buy1 = d4Buy1;
                indicator.D4Buy2 = d4Buy2;
                indicator.D4Sell1 = d4Sell1;
                indicator.D4Sell2 = d4Sell2;
                indicator.D5Buy1 = d5Buy1;
                indicator.D5Buy2 = d5Buy2;
                indicator.D5Sell1 = d5Sell1;
                indicator.D5Sell2 = d5Sell2;
                indicator.D6Buy1 = d6Buy1;
                indicator.D6Buy2 = d6Buy2;
                indicator.D6Sell1 = d6Sell1;
                indicator.D6Sell2 = d6Sell2;
                indicator.D7Buy1 = d7Buy1;
                indicator.D7Buy2 = d7Buy2;
                indicator.D7Sell1 = d7Sell1;
                indicator.D7Sell2 = d7Sell2;
                indicator.Sz1 = sz1;
                indicator.Sz2 = sz2;
                indicator.Zone = zone;
                indicator.Zseperation = zseperation;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                ARCTimeOfDay[] tmp = new ARCTimeOfDay[cacheARCTimeOfDay == null ? 1 : cacheARCTimeOfDay.Length + 1];
                if (cacheARCTimeOfDay != null)
                    cacheARCTimeOfDay.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheARCTimeOfDay = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCBigBenda ARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.ARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCBigBenda ARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.ARCBigBenda(input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCDonchain ARCDonchain(int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return _indicator.ARCDonchain(Input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCDonchain ARCDonchain(Data.IDataSeries input, int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return _indicator.ARCDonchain(input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCEmafan ARCEmafan(int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return _indicator.ARCEmafan(Input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCEmafan ARCEmafan(Data.IDataSeries input, int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return _indicator.ARCEmafan(input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCMacDiv ARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCMacDiv ARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCMacDiv(input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCNR10 ARCNR10(string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return _indicator.ARCNR10(Input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCNR10 ARCNR10(Data.IDataSeries input, string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return _indicator.ARCNR10(input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCPinBar ARCPinBar(int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCPinBar(Input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCPinBar ARCPinBar(Data.IDataSeries input, int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCPinBar(input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCRetracer ARCRetracer(int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCRetracer(Input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCRetracer ARCRetracer(Data.IDataSeries input, int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCRetracer(input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCSQ1001 ARCSQ1001(int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return _indicator.ARCSQ1001(Input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCSQ1001 ARCSQ1001(Data.IDataSeries input, int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return _indicator.ARCSQ1001(input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCTimeOfDay ARCTimeOfDay(int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return _indicator.ARCTimeOfDay(Input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCTimeOfDay ARCTimeOfDay(Data.IDataSeries input, int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return _indicator.ARCTimeOfDay(input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCBigBenda ARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.ARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCBigBenda ARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCBigBenda(input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCDonchain ARCDonchain(int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            return _indicator.ARCDonchain(Input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// The Donchian Channel indicator was created by Richard Donchian. It uses the highest high and the lowest low of a period of time to plot the channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCDonchain ARCDonchain(Data.IDataSeries input, int periodA, int periodB, int periodC, int periodD, int periodE)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCDonchain(input, periodA, periodB, periodC, periodD, periodE);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCEmafan ARCEmafan(int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            return _indicator.ARCEmafan(Input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Colour changes when ema is rising
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCEmafan ARCEmafan(Data.IDataSeries input, int fema1, int fema2, int fema3, int fema4, int fema5, int fema6, int fema7, bool risingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCEmafan(input, fema1, fema2, fema3, fema4, fema5, fema6, fema7, risingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCMacDiv ARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCMacDiv ARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCMacDiv(input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCNR10 ARCNR10(string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            return _indicator.ARCNR10(Input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCNR10 ARCNR10(Data.IDataSeries input, string nr10text, int period, int seperation, bool wordingon, bool zstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCNR10(input, nr10text, period, seperation, wordingon, zstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCPinBar ARCPinBar(int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCPinBar(Input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Highlight bar if it is the narrowest.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCPinBar ARCPinBar(Data.IDataSeries input, int barcount, string bearpintext, double bodysize, string bullpintext, int seperation, bool thistimeperiodon, int timeperiodA, int timeperiodB, bool timeperiodon, bool wordingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCPinBar(input, barcount, bearpintext, bodysize, bullpintext, seperation, thistimeperiodon, timeperiodA, timeperiodB, timeperiodon, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCRetracer ARCRetracer(int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.ARCRetracer(Input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Counts bars of a retrace plots a zone.
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCRetracer ARCRetracer(Data.IDataSeries input, int counter, string reTracetext, int seperation, int trend, bool wordingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCRetracer(input, counter, reTracetext, seperation, trend, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCSQ1001 ARCSQ1001(int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            return _indicator.ARCSQ1001(Input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCSQ1001 ARCSQ1001(Data.IDataSeries input, int ema1, int entry, int exit, int seperation, int trend, double zone, bool zstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCSQ1001(input, ema1, entry, exit, seperation, trend, zone, zstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ARCTimeOfDay ARCTimeOfDay(int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            return _indicator.ARCTimeOfDay(Input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }

        /// <summary>
        /// Shade the background when Buy and Sell times arrive
        /// </summary>
        /// <returns></returns>
        public Indicator.ARCTimeOfDay ARCTimeOfDay(Data.IDataSeries input, int apenw, string bz1, string bz2, int d1Buy1, int d1Buy2, int d1Sell1, int d1Sell2, int d2Buy1, int d2Buy2, int d2Sell1, int d2Sell2, int d3Buy1, int d3Buy2, int d3Sell1, int d3Sell2, int d4Buy1, int d4Buy2, int d4Sell1, int d4Sell2, int d5Buy1, int d5Buy2, int d5Sell1, int d5Sell2, int d6Buy1, int d6Buy2, int d6Sell1, int d6Sell2, int d7Buy1, int d7Buy2, int d7Sell1, int d7Sell2, string sz1, string sz2, int zone, int zseperation, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ARCTimeOfDay(input, apenw, bz1, bz2, d1Buy1, d1Buy2, d1Sell1, d1Sell2, d2Buy1, d2Buy2, d2Sell1, d2Sell2, d3Buy1, d3Buy2, d3Sell1, d3Sell2, d4Buy1, d4Buy2, d4Sell1, d4Sell2, d5Buy1, d5Buy2, d5Sell1, d5Sell2, d6Buy1, d6Buy2, d6Sell1, d6Sell2, d7Buy1, d7Buy2, d7Sell1, d7Sell2, sz1, sz2, zone, zseperation, zzstrategyuse);
        }
    }
}
#endregion
